import { Tokenizer, IpadicFeatures } from 'kuromoji';
import { Ipadic2NodeOptions } from './utils/node';
import { ParserOptions } from './utils/parser';
export interface KujinOptions extends Ipadic2NodeOptions, ParserOptions {
    dicPath?: string;
}
export interface FindOptions {
    flat?: boolean;
}
export default class Kujin {
    dicPath: string;
    tokenizer: Tokenizer<IpadicFeatures> | undefined;
    ipadicOptions: Ipadic2NodeOptions;
    parserOptions: ParserOptions;
    constructor(kujinOptions?: KujinOptions);
    getTokenizer(): Promise<Tokenizer<IpadicFeatures>>;
    private normalize;
    private getNodes;
    jadge(ku: string, opts?: Ipadic2NodeOptions & ParserOptions): Promise<boolean>;
    find(ku: string, opts?: Ipadic2NodeOptions & ParserOptions & FindOptions): Promise<string | string[][]>;
    findAll(ku: string, opts?: ParserOptions & Ipadic2NodeOptions & FindOptions): Promise<string[] | string[][][]>;
}
