import { IpadicFeatures } from 'kuromoji';
export interface Node extends IpadicFeatures, NodeProps {
}
export interface NodeProps {
    head: boolean;
    tail: boolean;
}
export interface Ipadic2NodeOptions {
    noHeads?: Partial<IpadicFeatures>[];
    noTails?: Partial<IpadicFeatures>[];
    trims?: Partial<IpadicFeatures>[];
}
export declare const defaultIpadic2NodeOptions: {
    noHeads: {
        pos: string;
    }[];
    noTails: ({
        pos: string;
        conjugated_form: string;
    } | {
        pos: string;
        conjugated_form?: undefined;
    })[];
    trims: ({
        pos: string;
        surface_form?: undefined;
    } | {
        pos: string;
        surface_form: string;
    })[];
};
export declare const ipadic2Node: (features: IpadicFeatures[], ipadic2NodeOptions?: Ipadic2NodeOptions | undefined) => Node[];
