"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var object_1 = require("./object");
var nodeProps = {
    head: true,
    tail: true,
};
exports.defaultIpadic2NodeOptions = {
    noHeads: [
        {
            pos: '助詞',
        },
        {
            pos: '助動詞',
        },
        {
            pos: 'フィラー',
        },
    ],
    noTails: [
        {
            pos: '動詞',
            conjugated_form: '未然形',
        },
        {
            pos: '接頭詞',
        },
    ],
    trims: [
        {
            pos: '記号',
        },
        {
            pos: '名詞',
            surface_form: '!',
        },
        {
            pos: '名詞',
            surface_form: '?',
        },
        {
            pos: '名詞',
            surface_form: ')',
        },
    ],
};
exports.ipadic2Node = function (features, ipadic2NodeOptions) {
    var options = __assign({}, exports.defaultIpadic2NodeOptions, ipadic2NodeOptions);
    var noHeads = options.noHeads, noTails = options.noTails, trims = options.trims;
    var nodes = features
        .filter(function (_feature) { return !object_1.includeSamePropertyValue(_feature, trims); })
        .map(function (_feature) {
        var feature = __assign({}, _feature, nodeProps);
        feature.head = !object_1.includeSamePropertyValue(feature, noHeads);
        feature.tail = !object_1.includeSamePropertyValue(feature, noTails);
        return feature;
    });
    return nodes;
};
