"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultParserOpts = {
    rule: [5, 7, 5],
    exact: false,
};
var sutekana = /[ぁぃぅぇぉゃゅょゎァィゥェォャュョヮ]/g;
exports.parser = function (nodes, options) {
    var ku = [];
    var rulePosition = 0;
    var reading = 0;
    var fullRule = false;
    var _a = __assign({}, exports.defaultParserOpts, options), rule = _a.rule, exact = _a.exact;
    var addNode = function (_node, index) {
        if (!ku[index]) {
            ku[index] = [];
        }
        ku[index].push(_node);
    };
    var nextPosition = function () {
        rulePosition++;
    };
    var reset = function () {
        reading = 0;
    };
    for (var _i = 0, nodes_1 = nodes; _i < nodes_1.length; _i++) {
        var node = nodes_1[_i];
        var _read = (node.reading || node.surface_form).replace(sutekana, '');
        if (reading === 0 && !node.head) {
            ku = [];
            break;
        }
        reading += _read.length;
        if (reading < rule[rulePosition]) {
            addNode(node, rulePosition);
        }
        else if (reading === rule[rulePosition]) {
            addNode(node, rulePosition);
            nextPosition();
            reset();
            if (typeof rule[rulePosition] === 'undefined') {
                fullRule = true;
                if (!node.tail) {
                    ku = [];
                }
                break;
            }
        }
        else {
            ku = [];
            break;
        }
    }
    if (!fullRule) {
        return undefined;
    }
    if (exact && ku.reduce(function (pre, cur) { return pre + cur.length; }, 0) !== nodes.length) {
        return undefined;
    }
    return ku.length ? ku : undefined;
};
exports.joinNodes = function (nodes) {
    return nodes.map(function (_node) { return _node.map(function (_nd) { return _nd.surface_form; }); });
};
